module DC where

import Control.Parallel.Eden
import ParMap

dc_c :: (Trans a, Trans b) => 
       Int                         -- remaining depth
       -> (a -> Bool) -> (a -> b)  -- trivial? / solve
       -> (a -> [a]) -> ([b] -> b) -- split / combine (incl. input)
       ->  a -> b                  -- resulting mapping
dc_c depth trivial solve split combine x 
   = if depth < 1 then seqDC x
                  else error "you write it"
     where myself   = dc_c (depth - 1) trivial solve split combine
	   seqDC x  = if trivial x then solve x 
			           else combine (map seqDC (split x))
